#include <Button.h>
#include <elapsedMillis.h>

elapsedMillis timeElapsed; //declare global if you don't want it reset every time loop runs
elapsedMillis gameTimeElapsed;
int finalTime = 9000; //allowed game time (9000);
Button button1(2); // Connect your button between pin 2 and GND
Button button2(3); // Connect your button between pin 3 and GND
Button button3(4); // Connect your button between pin 4 and GND
Button button4(6); // Connect your button between pin 6 and GND
Button button5(7); // Connect your button between pin 7 and GND
Button button6(8); // Connect your button between pin 8 and GND

unsigned interval = 2000;
unsigned game_interval = 10000;
boolean acceptFlg = false;
int given[6];
int answer[6];
unsigned int braille[26][6] = {
  {0, 0, 1, 0, 0, 0}, // a-0
  {0, 1, 1, 0, 0, 0}, // b-1
  {0, 0, 1, 1, 0, 0}, // c-2
  {0, 0, 1, 1, 1, 0}, // d-3
  {0, 0, 1, 0, 1, 0}, // e-4
  {0, 1, 1, 1, 0, 0}, // f-5
  {0, 1, 1, 1, 1, 0}, // g-6
  {0, 1, 1, 0, 1, 0}, // h-7
  {0, 1, 0, 1, 0, 0}, // i-8
  {0, 1, 0, 1, 1, 0}, // j-9
  {1, 0, 1, 0, 0, 0}, // k-10
  {1, 1, 1, 0, 0, 0}, // l-11
  {1, 0, 1, 1, 0, 0}, // m-12
  {1, 0, 1, 1, 1, 0}, // n-13
  {1, 0, 1, 0, 1, 0}, // o-14
  {1, 1, 1, 1, 0, 0}, // p-15
  {1, 1, 1, 1, 1, 0}, // q-16
  {1, 1, 1, 0, 1, 0}, // r-17
  {1, 1, 0, 1, 0, 0}, // s-18
  {1, 1, 0, 1, 1, 0}, // t-19
  {1, 0, 1, 0, 0, 1}, //u-20
  {1, 1, 1, 0, 0, 1}, //v-21
  {0, 1, 0, 1, 1, 1}, // w-22
  {1, 0, 1, 1, 0, 1}, // x-23
  {1, 0, 1, 1, 1, 1}, //y-24
  {1, 0, 1, 0, 1, 1}, // z-25

};

bool start = false;
int count = 0;
void setup() {
  button1.begin();
  button2.begin();
  button3.begin();
  button4.begin();
  button5.begin();
  button6.begin();
  pinMode(13, OUTPUT);


  while (!Serial) { }; // for Leos
  Serial.begin(9600);
  randomSeed(analogRead(0));
  startGame();
}

void loop() {

  // int letter_no=0;

  //Button 1 // pin 2
  if (button1.toggled() && start == true) {
    if (button1.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 1 has been pressed");
      Serial.println("Play Dot 3 Audio Here");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;

    }
    else
    {
      Serial.println("Button 1 has been released");
    }
  }

  if ((timeElapsed > interval) && (button1.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[0] = 1; //update check array
    Serial.println("Key 1 condition met");
    timeElapsed = 0;
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;

  }
  else {
    acceptFlg = false;
  }

  //Button 2 // pin 3

  if (button2.toggled() && start == true) {
    if (button2.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 2 has been pressed");
      Serial.println("Play Dot 2 Audio Here");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;

    }
    else
    {
      Serial.println("Button 2 has been released");
    }
  }

  if ((timeElapsed > interval) && (button2.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[1] = 1; //update check array
    Serial.println("Key 2 condition met");
    timeElapsed = 0;
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;

  }
  else {
    acceptFlg = false;
  }

  //Button 3 // pin 4

  if (button3.toggled() && start == true) {
    if (button3.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 3 has been pressed");
      Serial.println("Play Dot 1 Audio Here");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;

    }
    else
    {
      Serial.println("Button 3 has been released");
    }
  }

  if ((timeElapsed > interval) && (button3.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[2] = 1; //update check array
    timeElapsed = 0;
    Serial.println("Key 3 condition met");
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;

  }
  else {
    acceptFlg = false;
  }


  // button 4 // pin 5

  if (button4.toggled() && start == true) {
    if (button4.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 4 has been pressed");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;
    }
    else
    {
      Serial.println("Button 4 has been released");
    }
  }

  if ((timeElapsed > interval) && (button4.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[3] = 1; //update check array
    timeElapsed = 0;
    Serial.println("Key 4 condition met");
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;


  }
  else {
    acceptFlg = false;
  }

  /* for button --5 */
  if (button5.toggled() && start == true) {
    if (button5.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 5 has been pressed");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;

    }
    else
    {
      Serial.println("Button 5 has been released");
    }
  }

  if ((timeElapsed > interval) && (button5.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[4] = 1; //update check array
    Serial.println("Key 5 condition met");
    timeElapsed = 0;
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;
  }
  // button 6 // pin 8

  if (button6.toggled() && start == true) {
    if (button6.read() == Button::PRESSED)
    {
      timeElapsed = 0;
      Serial.println("Button 6 has been pressed");
      digitalWrite(13, HIGH);
      delay(500);
      digitalWrite(13, LOW);
      delay(500);
      acceptFlg = true;
    }
    else
    {
      Serial.println("Button 6 has been released");
    }
  }

  if ((timeElapsed > interval) && (button6.read() == Button::PRESSED) && (!acceptFlg) && start == true)
  {
    answer[5] = 1; //update check array
    timeElapsed = 0;
    Serial.println("Key 6 condition met");
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    digitalWrite(13, HIGH);
    delay(200);
    digitalWrite(13, LOW);
    delay(200);
    acceptFlg = false;
  }
  else {
    acceptFlg = false;
  }
  //  Serial.print("Given array and answer array:");

  if (given[0] == answer[0] && given[1] == answer[1] && given[2] == answer[2] && given[3] == answer[3] && given[4] == answer[4] && given[5] == answer[5]) {
    restart();
    //clear answer array //restart game
    //play sound for win
  }
  // Serial.print(given[i]);
  // Serial.print(answer[i]);
  // Serial.println();

  if ((gameTimeElapsed > game_interval) && start)
  {
    Serial.println("timeout");
    Serial.println("play timeout audio+delay");
    restart();
  }
}



void restart()
{ Serial.println("WIN WIN");
  Serial.println("Win Win Audio Should play here");
  for (int i = 0; i <= 5; i++) {
    answer[i] = 0;
  }
  start = false;
  startGame();
}

void startGame()
{
  gameTimeElapsed = 0;
  int letter_no = (int)(random(0, 25));
  while (start == false) {
    Serial.println("Audio for call should play here");
    Serial.print("random Letter:");
    Serial.println(letter_no);
    Serial.print("letter array:");
    for (int i = 0; i <= 5; i++) {
      given[i] = (braille[letter_no][i]);
    }
    for (int i = 0; i <= 5; i++) {
      Serial.print(given[i]);
    }
    Serial.println();
    delay(600);
    start = true;
    break;
  }

}
